## pytorch-text 0.8.1

=== requirements.txt ===
# Progress bars on iterators
tqdm

# Downloading data and other files
requests

# Optional NLP tools
nltk
spacy
sacremoses
git+git://github.com/jekbradbury/revtok.git

# Documentation
Sphinx
sphinx_rtd_theme

# Required for tests only:

# Style-checking for PEP8
flake8==3.7.9

# Run unit tests
pytest

# Lets pytest find our code by automatically modifying PYTHONPATH
pytest-pythonpath

# Coverage statistics
pytest-cov
codecov

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = torchtext
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

docset: html
	doc2dash --name $(SPHINXPROJ) --icon $(SOURCEDIR)/_static/img/pytorch-logo-flame.png --enable-js --online-redirect-url http://pytorch.org/text/ --force $(BUILDDIR)/html/

	# Manually fix because Zeal doesn't deal well with `icon.png`-only at 2x resolution.
	cp $(SPHINXPROJ).docset/icon.png $(SPHINXPROJ).docset/icon@2x.png
	convert $(SPHINXPROJ).docset/icon@2x.png -resize 16x16 $(SPHINXPROJ).docset/icon.png

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
sphinx==2.4.4
sphinxcontrib-googleanalytics
-e git+git://github.com/pytorch/pytorch_sphinx_theme.git#egg=pytorch_sphinx_theme

=== third_party/CMakeLists.txt ===
# Old enough to support Ubuntu Xenial.
cmake_minimum_required(VERSION 3.5.1)

if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()

project(thirdparty CXX)
set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")

add_subdirectory(re2)
add_subdirectory(double-conversion)

=== debian/changelog ===
pytorch-text (0.8.1-1) unstable; urgency=medium

  * New upstream version 0.8.1
  * Add new B-Ds and change architecture from all to any.
  * Add debian/clean.
  * Patch upstream CMake to prevent it from building re2.
  * d/rules: Noop dh_auto_test.
  * Add ${shlibs:Depends} to the binary package dependency.

 -- Mo Zhou <lumin@debian.org>  Tue, 22 Dec 2020 18:01:13 +0800

pytorch-text (0.6.0-4) unstable; urgency=medium

  * Specify X-Python3-Version: 3.9 .
  * Apply wrap-and-sort.

 -- Mo Zhou <lumin@debian.org>  Wed, 25 Nov 2020 17:25:22 +0800

pytorch-text (0.6.0-3) unstable; urgency=medium

  * Disable python 3.9 for pybuild.
  * Update maintainer mail address to debian-ai@l.d.o.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 21 Oct 2020 15:31:41 +0800

pytorch-text (0.6.0-2) experimental; urgency=medium

  * Rename bin:pytorch-text to bin:python3-torchtext

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Aug 2020 12:37:59 +0800

pytorch-text (0.6.0-1) experimental; urgency=medium

  * Initial release. (Closes: #958891)

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Aug 2020 09:27:36 +0800

=== debian/control ===
Source: pytorch-text
Section: science
Homepage: https://github.com/pytorch/text
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-text.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-text
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               ninja-build,
               dh-python,
               python3-all,
               python3-nltk,
               python3-pytest,
               python3-requests,
               python3-sentencepiece,
               python3-setuptools,
               python3-six,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               python3-torch,
               python3-tqdm,
               libre2-dev, libdouble-conversion-dev, libtorch-dev,
               pybind11-dev,
               libsentencepiece-dev,
X-Python3-Version: 3.9

Package: python3-torchtext
Architecture: any
Depends: python3-torch, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
Recommends: python3-nltk
Description: Data loaders and abstractions for text and NLP
 This package consists of:
 .
  * torchtext.data: Generic data loaders, abstractions, and iterators for
    text (including vocabulary and word vectors)
  * torchtext.datasets: Pre-built loaders for common NLP datasets

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Spybuild --with python3

override_dh_auto_test:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pytorch-text-$1.tar.gz%" \
https://github.com/pytorch/text/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## pytorch-text 0.14.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)

# Most of the configurations are taken from PyTorch
# https://github.com/pytorch/pytorch/blob/0c9fb4aff0d60eaadb04e4d5d099fb1e1d5701a9/CMakeLists.txt

# Use compiler ID "AppleClang" instead of "Clang" for XCode.
# Not setting this sometimes makes XCode C compiler gets detected as "Clang",
# even when the C++ one is detected as "AppleClang".
cmake_policy(SET CMP0010 NEW)
cmake_policy(SET CMP0025 NEW)

# Suppress warning flags in default MSVC configuration.  It's not
# mandatory that we do this (and we don't if cmake is old), but it's
# nice when it's possible, and it's possible on our Windows configs.
if(NOT CMAKE_VERSION VERSION_LESS 3.15.0)
  cmake_policy(SET CMP0092 NEW)
endif()

project(torchtext)


# check and set CMAKE_CXX_STANDARD
string(FIND "${CMAKE_CXX_FLAGS}" "-std=c++" env_cxx_standard)
if(env_cxx_standard GREATER -1)
  message(
      WARNING "C++ standard version definition detected in environment variable."
      "PyTorch requires -std=c++14. Please remove -std=c++ settings in your environment.")
endif()

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_C_STANDARD 11)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Apple specific
if(APPLE)
  # Get clang version on macOS
  execute_process( COMMAND ${CMAKE_CXX_COMPILER} --version OUTPUT_VARIABLE clang_full_version_string )
  string(REGEX REPLACE "Apple LLVM version ([0-9]+\\.[0-9]+).*" "\\1" CLANG_VERSION_STRING ${clang_full_version_string})
  message( STATUS "CLANG_VERSION_STRING:         " ${CLANG_VERSION_STRING} )

  # RPATH stuff
  set(CMAKE_MACOSX_RPATH ON)

  set(CMAKE_SHARED_LIBRARY_SUFFIX ".so")
endif()

# Options
option(BUILD_TORCHTEXT_PYTHON_EXTENSION "Build Python extension" OFF)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(TORCH_INSTALL_PREFIX "${CMAKE_PREFIX_PATH}/../.." CACHE STRING "Install path for torch")
set(TORCH_COMPILED_WITH_CXX_ABI "-D_GLIBCXX_USE_CXX11_ABI=0" CACHE STRING "Compile torchtext with cxx11_abi")

find_library(TORCH_C10_LIBRARY c10 PATHS "${TORCH_INSTALL_PREFIX}/lib")
find_library(TORCH_LIBRARY torch PATHS "${TORCH_INSTALL_PREFIX}/lib")
find_library(TORCH_CPU_LIBRARY torch_cpu PATHS "${TORCH_INSTALL_PREFIX}/lib")

if(MSVC)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TORCH_COMPILED_WITH_CXX_ABI} -Wall ${TORCH_CXX_FLAGS}")

add_subdirectory(third_party)
add_subdirectory(torchtext/csrc)

=== requirements.txt ===
# Progress bars on iterators
tqdm

# Downloading data and other files
requests

# Optional NLP tools
nltk
spacy
sacremoses
git+https://github.com/jekbradbury/revtok.git

# Documentation
Sphinx

# Required for tests only:

# Run unit tests
pytest
expecttest
parameterized
torchdata

# Lets pytest find our code by automatically modifying PYTHONPATH
pytest-pythonpath

# Coverage statistics
pytest-cov
codecov

# To parse untrusted XML data
defusedxml

=== docs/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W  # turn warnings into errors
 SPHINXBUILD   = sphinx-build
 SPHINXPROJ    = torchtext
 SOURCEDIR     = source

=== docs/requirements.txt ===
Jinja2<3.1.0
sphinx==5.1.1
-e git+https://github.com/pytorch/pytorch_sphinx_theme.git@cece053#egg=pytorch_sphinx_theme
sphinx_gallery==0.11.1
matplotlib

=== third_party/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")


if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()

add_subdirectory(re2 EXCLUDE_FROM_ALL)
add_subdirectory(double-conversion EXCLUDE_FROM_ALL)
add_subdirectory(sentencepiece EXCLUDE_FROM_ALL)
add_subdirectory(utf8proc EXCLUDE_FROM_ALL)

=== examples/libtorchtext/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
project(libtorchtext_cpp_example)

SET(BUILD_TORCHTEXT_PYTHON_EXTENSION OFF CACHE BOOL "Build Python binding")

find_package(Torch REQUIRED)
message("libtorchtext CMakeLists: ${TORCH_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TORCH_CXX_FLAGS}")

add_subdirectory(../.. libtorchtext)
add_subdirectory(tokenizer)

=== torchtext/csrc/CMakeLists.txt ===
################################################################################
# libtorchtext
################################################################################
set(
  LIBTORCHTEXT_SOURCES
  clip_tokenizer.cpp
  common.cpp
  gpt2_bpe_tokenizer.cpp
  regex.cpp
  regex_tokenizer.cpp
  register_torchbindings.cpp
  sentencepiece.cpp
  vectors.cpp
  vocab.cpp
  bert_tokenizer.cpp
  )

set(
  LIBTORCHTEXT_INCLUDE_DIRS
  ${PROJECT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/third_party/sentencepiece/src
  $<TARGET_PROPERTY:re2,INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:double-conversion,INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:utf8proc,INCLUDE_DIRECTORIES>
  ${TORCH_INSTALL_PREFIX}/include
  ${TORCH_INSTALL_PREFIX}/include/torch/csrc/api/include
  )

set(
  LIBTORCHTEXT_LINK_LIBRARIES
  ${TORCH_C10_LIBRARY}
  ${TORCH_LIBRARY}
  ${TORCH_CPU_LIBRARY}
  re2
  double-conversion
  sentencepiece
  sentencepiece_train
  utf8proc
  )

set(
  LIBTORCHTEXT_COMPILE_DEFINITIONS
  TORCHTEXT_BUILD_MAIN_LIB)

function (define_library name source include_dirs link_libraries compile_defs)
  add_library(${name} SHARED ${source})
  target_include_directories(${name} PRIVATE ${include_dirs})
  target_link_libraries(${name} ${link_libraries})
  target_compile_definitions(${name} PRIVATE ${compile_defs})
  set_target_properties(${name} PROPERTIES PREFIX "")
  if (MSVC)
    set_target_properties(${name} PROPERTIES SUFFIX ".pyd")
  endif(MSVC)
  install(
    TARGETS ${name}
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION lib  # For Windows
    )
endfunction()

define_library(
  libtorchtext
  "${LIBTORCHTEXT_SOURCES}"
  "${LIBTORCHTEXT_INCLUDE_DIRS}"
  "${LIBTORCHTEXT_LINK_LIBRARIES}"
  "${LIBTORCHTEXT_COMPILE_DEFINITIONS}"
  )

if (APPLE)
  set(TORCHTEXT_LIBRARY libtorchtext CACHE INTERNAL "")
else()
  set(TORCHTEXT_LIBRARY -Wl,--no-as-needed libtorchtext -Wl,--as-needed CACHE INTERNAL "")
endif()


################################################################################
# _torchtext.so
################################################################################
if (BUILD_TORCHTEXT_PYTHON_EXTENSION)
  # See https://github.com/pytorch/pytorch/issues/38122
  find_library(TORCH_PYTHON_LIBRARY torch_python PATHS "${TORCH_INSTALL_PREFIX}/lib")
  if (WIN32)
    find_package(Python3 ${PYTHON_VERSION} EXACT COMPONENTS Development)
    set(ADDITIONAL_ITEMS Python3::Python)
  endif()
  function(define_extension name sources include_dirs link_libraries definitions)
    add_library(${name} SHARED ${sources})
    target_compile_definitions(${name} PRIVATE "${definitions}")
    target_include_directories(
      ${name} PRIVATE ${Python_INCLUDE_DIR} ${include_dirs})
    target_link_libraries(
      ${name}
      ${link_libraries}
      ${TORCH_PYTHON_LIBRARY}
      ${ADDITIONAL_ITEMS}
      )
    set_target_properties(${name} PROPERTIES PREFIX "")
    if (MSVC)
      set_target_properties(${name} PROPERTIES SUFFIX ".pyd")
    endif(MSVC)
    if (APPLE)
      # https://github.com/facebookarchive/caffe2/issues/854#issuecomment-364538485
      # https://github.com/pytorch/pytorch/commit/73f6715f4725a0723d8171d3131e09ac7abf0666
      set_target_properties(${name} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif()
    install(
      TARGETS ${name}
      LIBRARY DESTINATION .
      RUNTIME DESTINATION .  # For Windows
      )
  endfunction()

  set(
    EXTENSION_SOURCES
    register_pybindings.cpp
    vocab_factory.cpp
    )

  set(
    EXTENSION_INCLUDE_DIRS
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/third_party/sentencepiece/src
    $<TARGET_PROPERTY:re2,INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:double-conversion,INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:utf8proc,INCLUDE_DIRECTORIES>
    ${TORCH_INSTALL_PREFIX}/include
    ${TORCH_INSTALL_PREFIX}/include/torch/csrc/api/include
    )

  set(
    EXTENSION_LINK_LIBRARIES
    libtorchtext
  )

  define_extension(
    _torchtext
    "${EXTENSION_SOURCES}"
    "${EXTENSION_INCLUDE_DIRS}"
    "${EXTENSION_LINK_LIBRARIES}"
    "${LIBTORCHTEXT_COMPILE_DEFINITIONS}"
    )
endif()

=== examples/libtorchtext/tokenizer/CMakeLists.txt ===
add_executable(tokenize main.cpp)
target_link_libraries(tokenize "${TORCH_LIBRARIES}" "${TORCHTEXT_LIBRARY}")
set_property(TARGET tokenize PROPERTY CXX_STANDARD 14)

=== debian/changelog ===
pytorch-text (0.14.1-2) unstable; urgency=medium

  * Team upload.
  * d/control: set X-Python3-Version to 3.11 only (Closes: #1030735).

 -- Aron Xu <aron@debian.org>  Wed, 08 Feb 2023 19:06:35 +0800

pytorch-text (0.14.1-1) unstable; urgency=medium

  [ Mo Zhou ]
  * cme update dpkg-copyright.
  * Require python3-torch (>= 1.12.0~).
  * Bump X-Python3-Version to 3.10 (Closes: #1008924)
  * Override dh_auto_clean to no-op.
  * Refresh existing patches.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Aron Xu ]
  * Team upload
  * New upstream version 0.14.1
  * d/control: add 3.11 to X-Python3-Version
  * d/control: add 3.11 to X-Python3-Version
  * d/patches: add patch to avoid init submodules
  * d/rules: clean __pycache__ directories

 -- Aron Xu <aron@debian.org>  Thu, 02 Feb 2023 15:35:52 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://github.com/pytorch/text
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-text.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-text
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -20,12 +20,12 @@
                python3-six,
                python3-sphinx,
                python3-sphinx-rtd-theme,
-               python3-torch,
+               python3-torch (>= 1.12.0~),
                python3-tqdm,
                libre2-dev, libdouble-conversion-dev, libtorch-dev,
                pybind11-dev,
                libsentencepiece-dev,
-X-Python3-Version: 3.9
+X-Python3-Version: 3.11
 
 Package: python3-torchtext
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Spybuild --with python3

override_dh_auto_clean:
	find . -type d -name "__pycache__" -exec rm -rf {} \;

override_dh_auto_test:
	:

## pytorch-text 0.15.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,10 +24,10 @@
 if(env_cxx_standard GREATER -1)
   message(
       WARNING "C++ standard version definition detected in environment variable."
-      "PyTorch requires -std=c++14. Please remove -std=c++ settings in your environment.")
+      "PyTorch requires -std=c++17. Please remove -std=c++ settings in your environment.")
 endif()
 
-set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_C_STANDARD 11)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

=== requirements.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 pytest
 expecttest
 parameterized
-torchdata
+torchdata>0.5
 
 # Lets pytest find our code by automatically modifying PYTHONPATH
 pytest-pythonpath

=== docs/requirements.txt ===
Jinja2<3.1.0
sphinx==5.1.1
-e git+https://github.com/pytorch/pytorch_sphinx_theme.git@cece053#egg=pytorch_sphinx_theme
sphinx_gallery==0.11.1
matplotlib
regex

=== debian/changelog ===
pytorch-text (0.15.2-1) unstable; urgency=medium

  * New upstream version 0.15.2 (PyTorch 2.0.1)
  * Change recommends into suggests. Also suggest sentencepiece.
  * Export BUILD_VERSION for correct version info.
  * Amend the dh_auto_clean target. (Closes: #1048979, #1049494)

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Sep 2023 21:01:13 -0400

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
 Package: python3-torchtext
 Architecture: any
 Depends: python3-torch, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
-Recommends: python3-nltk
+Suggests: python3-nltk, python3-sentencepiece
 Description: Data loaders and abstractions for text and NLP
  This package consists of:
  .

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
export BUILD_VERSION=$(DEB_VERSION_UPSTREAM)

%:
	dh $@ -Spybuild --with python3

override_dh_auto_clean:
	-find . -type d -name "__pycache__" -exec rm -rf {} \;
	dh_auto_clean

override_dh_auto_test:
	:
